;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: lstypes.lisp,v 1.3 2005/12/26 20:34:24 dvm Exp $

(loading-bogus 
 This file appears to have been supplanted by tuptypes.lisp and other
 files.)

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on :at-run-time %nity/ types foundation vartypes tuptypes slotfeat)

(depends-on :at-compile-time %nity/ deftyp tupacceptors)

(in-type-system universal)

(def-type Null (Tup))

(def-type-fun Pair (u - (T) v - (TT)) (Tup u &rest (= v)))

(def-type-fun Lst (a) (Tup &rest e - a))

(defun make-lstype (elty)
   (let ((d (global-declaration 'Lst universal-type-sys* true)))
      (let ((lst-tyf (and (is-Vartype d)
			  (Vartype-val d))))
	 (cond ((is-Tyfun lst-tyf)
		(make-typeform lst-tyf
			       (list (new-Vartype 'a type-type* elty))))
	       (t
		(error-break make-lstype :fatal
		   "Fumbled Lst definition in universal-type-sys*: "
		   d))))))

(def-type-fun Dot (a - (T) d - (TT))
   (:system universal)
   (Tup x - a &rest l -- d))

;(def-type Null (Clump :subtype Obj
;                 (IS null)))

;(def-type-fun Lst (:system universal)
;     (eltype)
;     (Alt Null (Tup car &rest cdr - eltype)))



#|

(def-type-fun Lst (:system universal)
     (eltype)
     (Dot eltype eltype))

(defvar lst-type-fun*
   (Vartype-val (global-declaration 'Lst universal-type-sys* true)))


(def-type-fun Dot (a d)
   (:system universal)
   (Clump :subtype Obj
      (:feature cartype :type a)
      (:feature cdrtype :type b)
      (is (and (consp x)
	       (is a (car x))
	       (is d (cdr x))))))
|#





     ;(Alt Null (Tup x - eltype &rest l - eltype)))


