;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: simpleargs.lisp,v 1.4 2004/02/22 00:47:03 dvm Exp $

;;; This is for use by Svcplnr and optop
;;; We can only do maximal matches with simple predicates
;;; Returns < ok, list of types >
(defun simple-funtype-argtypes (ft)
   (cond ((= (type-find-feature ft 'level global-env*)
	     0)
	  (let ((atype (type-find-feature ft 'argtype global-env*)))
	     (cond (atype
		    (values true
			    (let ((alspec (type-find-feature atype 'elt-types '())))
			       (cond (alspec
				      (<# Argspec-type (alspec-args-sort alspec)))
				     (t
				      (list atype))))))
		   (t
		    (signal-problem simple-funtype-argtypes
		       "Not a funtype: " ft)))))
	 (t
	  (values false nil))))

(defun simple-funtype-restype (ft)
   (cond ((= (type-find-feature ft 'level global-env*)
	     0)
	  (let ((rtype (type-find-feature ft 'resulttype global-env*)))
	     (cond (rtype
		    (values true rtype))
		   (t
		    (signal-problem simple-funtype-argtypes
		       "Not a funtype: " ft)))))
	 (t
	  (values false nil))))
