;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: alttype.lisp,v 1.2 2004/02/22 00:46:56 dvm Exp $

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on :at-run-time %nity/ vartypes feature)

(def-type-class alt-class (:system :universal)
  (:var alt-class*))

(defvar type-tup-type* (make-type-of-class simple-typeform-class
			 '(TT)
			 '() type-type* '()
			 (list (tuple 'meta 'type)
			       (tuple 'home universal-type-sys*)
			       (tuple 'var 'type-tup-type*)
			       )))

(defun make-nontrivial-alt-type (alt-types sup-type vartypes)
   (let ((freevars
	    (</ (\\ (vl a)
		   (freevars-union vl (Type-freevars a)))
		'() alt-types)))
      (let ((alt-ty
	       (make-type-of-class (alt-class universal)
		  `(Alt ,@(<# (\\ (ty) (type-find-designator ty vartypes))
			      alt-types))
		  freevars univ-type* '()
		  (list (tuple 'alt-types (closure-or-closable
					     alt-types
					     vartypes
					     'close-elements
					     freevars))
			(tuple 'kind
			       (cond ((forall (ty in alt-types)
					 (eq (type-find-kind ty vartypes)
					     type-tup-type*))
				      type-tup-type*)
				     (t type-type*)))))))
	 (type-set-supertype alt-ty sup-type vartypes)
	 alt-ty)))

