;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: contype.lisp,v 1.5 2004/02/22 00:46:58 dvm Exp $

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on (:at :run-time :compile-time) %nity/ types foundation)

(defun make-nontrivial-const-type (consts sup-type)
	  (make-type-of-class (const-class universal)
	     `(Con ,@consts)
	     '()
	     sup-type
	     '()
	     (list (tuple 'is-tester
			  (repeat :for ((c :in consts)
				       (specials '())
				       (ordinaries '()))
			     (let ((s (assq c
					    '((empty-list
						 (null x))
					      (true (eq x true))
					      (false (not x))))))
				(cond (s
				       (!= specials
					   (cons (cadr s) *-*)))
				      (t
				       ;; Must look like ('quote' actual-const)
				       (!= ordinaries
					   (cons (cadr c) *-*)))))
			   :result
			     `(:inline (x)
				 (or ,@specials
				     ,@(include-if
					  (not (null ordinaries))
					  `(member x ',ordinaries
						   :test #'equal))))))
		   (tuple 'consts consts))))

