;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: funtypes.lisp,v 1.2 2004/02/22 00:47:01 dvm Exp $

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on :at-run-time %nity/ types foundation desigsubst)

(defun degenerate-function (&rest a) 
   (out (:to *error-output*)
	"Function intended for initializations only was actually"
	:% " called, with arguments "(<# condense a) :%)
   nil   )

(def-type-class fun-class universal
   (:var fun-class*)
   (:feature is-fun-type true)
   (:feature initexp #'degenerate-function))

(datafun desig-subst Fun
   (defun (d bvars env)
      (multi-let (((lev matter)
		   (cond ((is-Number (cadr d))
			  (values `(,(cadr d)) (cddr d)))
			 (t
			  (values '() (cdr d))))))
	 (match-cond matter
	    ?( (?res <- ?arg ?@stuff)
	       `(Fun ,@lev
		     ,(desig-subst
			 res
			 (cond ((and (not (null lev))
				     (> (car lev) 0))
				(append
				   (extract-vars arg)
				   bvars))
			       (t bvars))
			 env)
		     <-
		     ,(desig-subst arg bvars env)
		     ,@stuff))
	    (t d)))))
